#include <xpseudo_asm.h>
#include "xexception_l.h"
#include "xbasic_types.h"
#include "xintc.h"
#include "sleep.h"

#include "raid_sim.h"



int request_reconstruct(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00000011);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00000021);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00000031);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00000041); 
//set up address for Parity data
mtdcr(RAID_P, 0x00000051);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00000061);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000004);
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}


int gen_gf(void) {


//set up to write the GFLOG BRAM
mtdcr(RAID_LOAD_FORMAT, 0x0000002);

//need to figure out how to write the data to RAID6 BRAM block of the OCM??????
//???

gen_table(32);

//set up to write the GFILOG BRAM
mtdcr(RAID_LOAD_FORMAT, 0x0000001);

gen_table(256);

return 0;


}

int gen_table(int s) {
//this code was taken from Intel whitepaper Intelligent RAID6 
//Theory Overview and Implementation
//are there any issues with this??????

//***************************************************
//This routine is used to create logarithm and 
//inverse lagarithm tables for computing P&Q parity.
//
//P is always 1
//***************************************************

unsigned int    b, index, gf_elements;
//polynomial = x^8 + x^4 + x^3 + x^2 + 1
unsigned int    prim_poly_8 = 0x11d;
unsigned short  *gflog, *gfilog;
char *memptr;
char *memptr2;
unsigned char b_index;
unsigned long i;

//memptr = (char *)0xFE004000;
//memptr2 = (char *)0XFE004000;

gflog = (unsigned short *)0xFE004000;
gfilog = (unsigned short *)0xFE004200;

//for( i = 0; i < 2*12; i++)
//{
//  memptr[i] = i;
//}

//convert s to the number of elements for the table
gf_elements = 256;
//gf_elements = 1<<s;
//gflog = (unsigned short *)malloc(sizeof(unsigned short) *gf_elements);
//gfilog = (unsigned short *)malloc(sizeof(unsigned short) *gf_elements);

b=1;

for(index=0; index < gf_elements-1; index++)
{
  gflog[b] = (unsigned char)index;
  //matts code below
  //memptr += index;
  //memptr[index] = gflog[b];
  //memptr[index] = gflog[b]; 
  //memptr = memptr2;
  //end of matts code
  gfilog[index] = (unsigned char) b;
  //memptr[index] = gfilog[index];
  b<<=1;
  if(b & gf_elements)
    b ^= prim_poly_8;
}
//for( i = 0; i < 2*12; i++)
//{
//  memptr[i] = gfilog;
//}
return 0;


}
