#include "xuartlite_l.h"
#include "xexception_l.h"
#include "xbasic_types.h"
#include "xintc.h"
#include "sleep.h"


#include <xpseudo_asm.h>
#include "xparameters.h"
#include "uart_test.h"

//uart functions stuff

  // data buffers
  
  Xuint8 buf_pio[BUF_PIO_SIZE];

int main(void) {


Xuint32 b;  // loop invariants


  int tmp;

  unsigned long data_start1 = 0x00000100;
  unsigned long data_start2 = 0x00020001;
  unsigned long data_start3 = 0x03000002;
  unsigned long addr_start1 = 0x00010000;
  unsigned long addr_start2 = 0x00020000;
  unsigned long addr_start3 = 0x00030000;
  unsigned long i;
  unsigned long y = addr_start1;
  unsigned long j;
  unsigned long z;
  unsigned long p;

  unsigned long checkdata;
  unsigned long confirmdata;
  unsigned long writtendata = data_start1 + 0x01010101;

  //setup_uart();             // clear screen and reset cursor



//  
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  usleep(1);

 //   }

  // won't reach this statement, but let's suppress compiler warnings
//  return 0;

  xil_printf("\n\rloading the memory with data\r");
  xil_printf("\n.\n");

  //load first data block
  //ddr_mpmc_load(0x00010000,data_start1);
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
 
  xil_printf("\n..\n");

  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  
  xil_printf("\n...\n");
  //load third data block
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;

 
  for(p = y;  p < y + 512; p=p+4 )
  {
    confirmdata = ddr_mpmc_read(p); 
  //if(p < y+80){
  //xil_printf("\n0x%08X\r",confirmdata);
 // }
  //usleep(1000000);
  }

  //xil_printf("\n\rdone confirming data&&&&&&&&\r");
  
  mtdcr(RAID_SIZE, 0x80000001);//512 block
  //xil_printf("\n\rMemory Blocks initialized.\r");

  mtdcr(RAID_LED, 0x00000001);

  usleep(11);
 
  request_reconstruct_p();

  xil_printf("\n\rReconstruct the P parity...\r");

  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_q();
  }

  xil_printf("\n\rReconstruct the Q parity...\r");
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0();
  }
  xil_printf("\n\rReconstruct the Data1 ...\r");
  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1();
  }
  xil_printf("\n\rReconstruct the Data2... ...\r");
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2();
  }
  xil_printf("\n\rReconstruct the Data3... ... ...\r");
   
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_p_q();
  }
  xil_printf("\n\rReconstruct the P and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_q();
  }
  xil_printf("\n\rReconstruct the Data1 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_q();
  }
  xil_printf("\n\rReconstruct the Data2 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_q();
  }
  xil_printf("\n\rReconstruct the Data3 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_p();
  }
  xil_printf("\n\rReconstruct the Data1 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_p();
  }
  xil_printf("\n\rReconstruct the Data2 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_p();
  }
  xil_printf("\n\rReconstruct the Data3 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_d1();
  }
  xil_printf("\n\rReconstruct the Double data 1 & 2\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_d2();
  }
  xil_printf("\n\rReconstruct the Double data 2 & 3\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_d0();
  }
  xil_printf("\n\rReconstruct the Double data 3 & 1\r");

  usleep(10);
  z = 0;
  xil_printf("\n\r##############################################\r");
  xil_printf("\n\r#Reconstruction is complete now checking data#\r");
  xil_printf("\n\r##############################################\r");
  for(i = y;  i < y + 512; i=i+4 )
  {
    checkdata = ddr_mpmc_read(i);
	//if( i < y + 20){
      //xil_printf("\n\rData is wrong?????????????\r");
	 // xil_printf("\n\rread data is ......\r");
     // xil_printf("\n0x%08X\n",checkdata);
     // xil_printf("\n\rdata should be ......\r");
     // xil_printf("\n0x%08X\n",writtendata);
	 // }
    if(checkdata == writtendata)
    {
	   //xil_printf("\n\rData is correct!!!!!!!!!!!!!!!!\r");
	   //xil_printf("\n\rread data is ......\r");
       //xil_printf("\n0x%08X\n",checkdata);
       mtdcr(RAID_LED, 0x00000003);
    }
    else
    {
	  z= z+1;
	   
	  //if( i < y + 80){
      xil_printf("\n\rread data is ......\r");
      xil_printf("\n0x%08X\n",checkdata);
      xil_printf("\n\rdata should be ......\r");
      xil_printf("\n0x%08X\n",writtendata);
	  usleep(100000);
	  //}
	  tmp = mfdcr(RAID_LED);
      if(tmp == 0x0000003 || tmp == 0x00000007){
	    mtdcr(RAID_LED, 0x00000007);
	  }
	  else{ 
	    mtdcr(RAID_LED, 0x00000004);
	  }
    }
	writtendata = writtendata + 0x01010101; 
  }
    tmp = mfdcr(RAID_LED);
    if(tmp == 0x00000003){
       mtdcr(RAID_LED, 0x0000000B);
	   xil_printf("\n\rData test complete:  no errors !\r");
	}
	else if(tmp == 0x00000007){
      mtdcr(RAID_LED, 0x0000000F);
	  xil_printf("\n\rData test complete:  some errors !\r");
	  xil_printf("\n\rnumber of errors is\r");
      xil_printf("\n0h%08X\n", z);
	}
	else{
      mtdcr(RAID_LED, 0x0000000D);
	  xil_printf("\n\rData test complete:  no good data !\r");
	  xil_printf("\n\rnumber of errors is\r");
      xil_printf("\n0h%08X\n", z);
	}

   usleep(8);
   data_start1 = 0x03020101;
   data_start2 = 0x04030202;
   addr_start1 = 0x00010000;
   addr_start2 = 0x00020000;
 
  
  writtendata = data_start1 + 0x01010101;
  xil_printf("\n\rUpdate data, P parity and Q parity....!\r");

  usleep(7);
  //load first data block
  //ddr_mpmc_load(0x00010000,data_start1);
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  //ddr_mpmc_load(addr_start1,data_start1);
 


  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  //ddr_mpmc_load(addr_start2,data_start2);
  


tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d0();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d1();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d2();
  }
usleep(2);
  xil_printf("\n\rSoftware test is complete have a nice day !!!!!\r");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");

  xil_printf("\n*******************************************************\r");
  xil_printf("\n*     Welcome to the RAID6 Demo                        *\r");
  xil_printf("\n*************************************                 ***\r");
  xil_printf("\n********************************                    ******\r");
  xil_printf("\n***************************                       *********\r");
  xil_printf("\n**********************                          ************\r");
  xil_printf("\n*****************                             ***************\r");
  xil_printf("\n************                                ******************\r");
  xil_printf("\n*******                                   *********************\r");
  xil_printf("\n*                                              *****************\r");
  xil_printf("\n*  Please choose the function                               *****\r");
  xil_printf("\n*  to Clear Memory           clr1,2,3,p,q,or a for all         ***\r");
  xil_printf("\n*  to Write a Data block     wr1,2,3 [8-bit hex value]          **\r");
  xil_printf("\n*  to Read a Data block      rd1,2,3,p, or q                    *\r");
  xil_printf("\n*  to Generate Parity Blocks genp or genq                      *\r");
  xil_printf("\n*  to Check Data             check                            *\r");
  xil_printf("\n*  to initialize Data        init                            *\r");
  xil_printf("\n*************************************************************\r");
  xil_printf("\n\r");
  
  
while(TRUE) {

for(b = 0; b < 512; b++) buf_pio[b] = 0;


get_command(buf_pio);


  // choose command
    switch(buf_pio[0]) {
      case '0': xil_printf("\n...\r");  break;
      case '1': xil_printf("\ncalling clear data1\n\r");
				break;
      case '2': xil_printf("\ncalling clear data2\n\r");
				break;
      case '3': xil_printf("\ncalling clear data3\n\r");
				break;
      case '4': xil_printf("\ncalling clear Pparity\n\r");
				break;
      case '5': xil_printf("\ncalling clear Qparity\n\r");
	            break;
      case '6': xil_printf("\ncalling clear all blocks\n\r");
	            break;
      case '7': xil_printf("\ncalling write data1\n\r");
	            break;
	  case '8': xil_printf("\ncalling write data2\n\r");
				break;
      case '9': xil_printf("\ncalling write data3\n\r");
				break;
      case 'a': xil_printf("\ncalling read data1\n\r");
	            break;
	  case 'b': xil_printf("\ncalling read data2\n\r");
				break;
      case 'c': xil_printf("\ncalling read data3\n\r");
				break;
      case 'd': xil_printf("\ncalling read Pparity\n\r");
				break;
      case 'e': xil_printf("\ncalling read Qparity\n\r");
	            break;
      case 'f': xil_printf("\ncalling initialize\n\r");
	            break;
      case 'g': xil_printf("\ncalling check\n\r");
	            break;
      case 'z': xil_printf("\nb\r");  
	            break;

      default:  xil_printf("\n0x%08X\r",buf_pio[0]); break;
   }  
//usleep(10);
}
   


}


/////////////////////////////////////////////////////////////
//below are functions for the uart
/////////////////////////////////////////////////////////////
/*
void get_command(Xuint8 *buf) {

  Xuint8 i = 0, j = 0;
  Xuint8 c;
  Xuint8 tmp[10];
  Xuint8 args = 0;
  Xuint8 a0, a1, a2;
  Xuint8 h, t, o;

  while((c = inbyte(0)) != 10) { // not newline

    if((c == 0x08) && (i > 0)) {  // backspace and not at buffer start

      outbyte(0x08);
      outbyte(' ');
      outbyte(0x08);
      i--;

    }

    else if((c >= 32) && (c <= 126) && (i < 9)) {  // normal char & not buf end

      outbyte(c);
      buf[i++] = c;

    }

  }

  // terminate string
  buf[i] = 0;

  // move to next non-space character
  for(i = 0; (i < 10) && (buf[i] == ' '); i++);

  // copy data into temporary buffer
  for(j = 0; (i < 10) && (buf[i] != ' '); i++, j++)
    tmp[j] = buf[i];

  // move to next non-space character
  for(i = i; (i < 10) && (buf[i] == ' '); i++);

  // copy data into temporary buffer
  for(i = i, j = j; (i < 10) && (buf[i] != ' '); i++, j++) {

    tmp[j] = buf[i];

    // do we have arguments?
    if((buf[i] >= 32) && (buf[i] <= 126))
      args = 1;

  }

  // copy data into temporary buffer
  for(i = i, j = j; j < 10; i++, j++)
    tmp[j] = buf[i];

  // copy command selection parameter and arguments into input buffer
  if(tmp[0] == 'a')  {

    buf[0] = 'a';
    buf[1] = 0;
    return;

  }

  else if(tmp[0] == 'b')  {

    buf[0] = 'b';
    buf[1] = 0;
    return;

  }

  else if(tmp[0] == 'c')  {

    buf[0] = 'c';
    buf[1] = 0;
    return;

  }

  else if(tmp[0] == 'd')  {

    buf[0] = 'd';
    buf[1] = 0;
    return;

  }

  else if(tmp[0] == 'e')  {

    buf[0] = 'e'; 
    buf[1] = 0;

    return;

  }

  else if(tmp[0] == 'f') {

    buf[0] = 'f';
    buf[1] = 0;
   

    return;

  }
  
  else if(tmp[0] == 'g') {

    buf[0] = 'g';
	buf[1] = 0;

       return;

  }
  
   // otherwise, command is unrecognized
  else {

    buf[0] = 0;
    xil_printf("\n\rUnrecognized Command.\n\r");
    return;

  }

}
*/
void get_command(Xuint8 *buf) {

  Xuint8 i = 0, j = 0;
  Xuint8 c;
  Xuint8 tmp[10];
  Xuint8 args = 0;
  Xuint8 a0, a1, a2;
  Xuint8 h, t, o;

 

  //while((c = inbyte(0)) != 10) { // not newline //also '\r'
  while((c = inbyte(0)) != '\r') {

    if((c == 0x08) && (i > 0)) {  // backspace and not at buffer start
      outbyte(0x08);
      outbyte(' ');
      outbyte(0x08);
      i--;

    }

    else if((c >= 32) && (c <= 126) && (i < 9)) {  // normal char & not buf end
         outbyte(c);
      buf[i++] = c;

    }

  }

  // terminate string
  buf[i] = 0;


  // move to next non-space character
  for(i = 0; (i < 10) && (buf[i] == ' '); i++);
   

  // copy data into temporary buffer
  for(j = 0; (i < 10) && (buf[i] != ' '); i++, j++)
    tmp[j] = buf[i];

  // move to next non-space character
  for(i = i; (i < 10) && (buf[i] == ' '); i++);

  // copy data into temporary buffer
  for(i = i, j = j; (i < 10) && (buf[i] != ' '); i++, j++) {

    tmp[j] = buf[i];
    // do we have arguments?
    if((buf[i] >= 32) && (buf[i] <= 126))
      args = 1;

  }

  // copy data into temporary buffer
  for(i = i, j = j; j < 10; i++, j++)
    tmp[j] = buf[i];

  // copy command selection parameter and arguments into input buffer
  if((tmp[0] == 'c') && (tmp[1] == 'l') &&(tmp[2] == 'r')) {
    if(tmp[3] == '1') {
xil_printf("\nclearing data 1\r");
    buf[0] = '1';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '2') {
xil_printf("\nclearing data 2\r");
    buf[0] = '2';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '3') {
xil_printf("\nclearing data 3\r");
	buf[0] = '3';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == 'p') {
xil_printf("\nclearing P parity\r");
    buf[0] = '4';
    buf[1] = 0;
    return; 
	}
    else if(tmp[3] == 'q') {
xil_printf("\nclearing Q parity\r");
    buf[0] = '5';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == 'a') {
	xil_printf("\nclearing all blocks\r");
    buf[0] = '6';
    buf[1] = 0;
    return; 
	}
	else {
xil_printf("\ninvalid clear command\r");
xil_printf("\nvalid commands are clr1 clr2 clr3 clrp clrq or clra \r"); 
    buf[0] = '0';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'w') && (tmp[1] == 'r') ) {
    if(tmp[2] == '1') {
    xil_printf("\nwriting data 1\r");
    buf[0] = '7';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '2') {
    xil_printf("\nwriting data 2\r");
    buf[0] = '8';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '3') {
    xil_printf("\nwriting data 3\r");
	buf[0] = '9';
    buf[1] = 0;
    return; 
	}
	else {
    xil_printf("\ninvalid write command\r");
    xil_printf("\nvalid commands are wr1 wr2 wr3 \r"); 
    buf[0] = '0';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'r') && (tmp[1] == 'd') ) {
    if(tmp[2] == '1') {
    xil_printf("\nreading data 1\r");
    buf[0] = 'a';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '2') {
    xil_printf("\nreading data 2\r");
    buf[0] = 'b';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '3') {
    xil_printf("\nreading data 3\r");
	buf[0] = 'c';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == 'p') {
    xil_printf("\nreading P parity\r");
    buf[0] = 'd';
    buf[1] = 0;
    return; 
	}
    else if(tmp[2] == 'q') {
    xil_printf("\nreading Q parity\r");
    buf[0] = 'e';
    buf[1] = 0;
    return; 
	}
	else {
    xil_printf("\ninvalid read command\r");
    xil_printf("\nvalid commands are rd1 rd2 rd3 rdp rdq \r"); 
    buf[0] = '0';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'i') && (tmp[1] == 'n') && (tmp[2] == 'i') && (tmp[3] == 't')) {
    xil_printf("\ninitializing data 1\r");
    buf[0] = 'f';
    buf[1] = 0;
    return; 
	}
  else if((tmp[0] == 'c') && (tmp[1] == 'h') && (tmp[2] == 'e') && (tmp[3] == 'c') && (tmp[4] == 'k')) {
    xil_printf("\nchecking data 1\r");
    buf[0] = 'g';
    buf[1] = 0;
    return; 
	}





  else if(tmp[0] == 'b') {
xil_printf("\nyou have entered an b\r");
    buf[0] = 'b';
    buf[1] = 0;
    return;

  }

  else if((tmp[0] == 's') && (tmp[1] == 'p') && (tmp[2] == 'd') && 
         (tmp[3] == 'm') && (tmp[4] == 'p') && (tmp[5] == 0) && (args == 0)) {
xil_printf("\ninside d\r");
    buf[0] = 'd';
    buf[1] = 0;
    return;

  }

  else if((tmp[0] == 's') && (tmp[1] == 'p') && (tmp[2] == 'l') && 
         (tmp[3] == 'b') && (tmp[4] == 'l') && (tmp[5] == 0) && (args == 0)) {
xil_printf("\ninside l\r");
    buf[0] = 'l';
    buf[1] = 0;
    return;

  }

  else if((tmp[0] == 'r') && (tmp[1] == 'e') && (tmp[2] == 'a') && 
         (tmp[3] == 'd')) {
xil_printf("\ninside r\r");
    buf[0] = 'r';

    a0 = tmp[4];
    a1 = tmp[5];
    a2 = tmp[6];

    // put sector number into arguments
    if((a0 < '0') || (a0 > '9'))
      buf[1] = 0;

    else if((a1 < '0') || (a1 > '9'))
      buf[1] = a0 - '0';

    else if ((a2 < '0') || (a2 > '9'))
      buf[1] = (10*(a0 - '0')) + a1 - '0';

    else
      buf[1] = (100*(a0 - '0')) + (10*(a1 - '0')) + a2 - '0';

    return;

  }

  else if((tmp[0] == 'w') && (tmp[1] == 'a') && (tmp[2] == 'i') && 
         (tmp[3] == 't') && (tmp[4] == 'e')) {
xil_printf("\ninside w\r");
    buf[0] = 'w';

    a0 = tmp[5];
    a1 = tmp[6];
    a2 = tmp[7];

    // put sector number into arguments
    if((a0 < '0') || (a0 > '9'))
      buf[1] = 0;

    else if((a1 < '0') || (a1 > '9'))
      buf[1] = a0 - '0';

    else if ((a2 < '0') || (a2 > '9'))
      buf[1] = (10*(a0 - '0')) + a1 - '0';

    else
      buf[1] = (100*(a0 - '0')) + (10*(a1 - '0')) + a2 - '0';

    return;

  }
  
  else if((tmp[0] == 'm') && (tmp[1] == 'd') && (tmp[2] == 't') && 
         (tmp[3] == 's') && (tmp[4] == 't')) {
xil_printf("\ninside t\r");
    buf[0] = 't';

    a0 = tmp[5];
    a1 = tmp[6];
    a2 = tmp[7];

    // put sector number into arguments
    if((a0 == '0') && (a1 == '0'))
      buf[1] = 0;

    else if((a0 == '0') && (a1 == '1'))
      buf[1] = 1;

    else if ((a0 == '1') && (a1 == '0'))
      buf[1] = 2;

    else if ((a0 == '1') && (a1 == '1'))
      buf[1] = 3;
      
    else {
    	
      buf[0] = 0;
      xil_printf("\n\rUsage: mdtst [00 | 01 | 10 | 11]\n\r");
    	
    }

    return;

  }
  
  else if((tmp[0] == 's') && (tmp[1] == 'p') && (tmp[2] == 's') && 
  (tmp[3] == 'l') && (tmp[4] == 'p') && (tmp[5] == 0) && (args == 0)) {
xil_printf("\ninside s\r");
    buf[0] = 's';
    return;

  }
  
  else if((tmp[0] == 's') && (tmp[1] == 'p') && (tmp[2] == 's') && 
         (tmp[3] == 't') && (tmp[4] == 'b') && (tmp[5] == 0) && (args == 0)) {
xil_printf("\ninside b\r");
    buf[0] = 'b';
    return;

  }
  
  else if((tmp[0] == 's') && (tmp[1] == 'p') && (tmp[2] == 'r') && 
         (tmp[3] == 's') && (tmp[4] == 't') && (tmp[5] == 0) && (args == 0)) {
xil_printf("\ninside e\r");
    buf[0] = 'e';
    return;

  }
  
  else if((tmp[0] == 'd') && (args == 0)) {
xil_printf("\ninside a\r");
    buf[0] = 'a';
    return;

  }

  else if((tmp[0] == 'v') && (args ==0)) {
xil_printf("\ninside v\r");
    buf[0] = 'v';
    return;

  }

  // otherwise, command is unrecognized
  else {

    buf[0] = 0;
    xil_printf("\n\rUnrecognized Command.\n\r");
    return;

  }

}
