#ifndef SATADEMO_H
#define SATADEMO_H

// define base address of SATA core
#define SATA_BASE 0x200
//define DCR addresses for RAID information
#define RAID_RECON 0x180
#define RAID_LOST 0x181
#define RAID_1 0x182
#define RAID_2 0x183
#define RAID_3 0x184
#define RAID_4 0x185
#define RAID_P 0x186
#define RAID_Q 0x187
#define RAID_M 0x188
#define RAID_GFC_STATUS 0x189
#define RAID_LED 0x18A
#define RAID_SIZE 0x18B

//#define SECTOR_SIZE 512
//#define BUF_PIO_SIZE SECTOR_SIZE * 1024
#define BUF_PIO_SIZE 512

// TRUE and FALSE - always nice to have around
#define TRUE  1
#define FALSE 0

void get_command(Xuint8 *);

void init_mem();

void read_block(unsigned long addr);

void user_write(unsigned long addr, Xuint8 data);

void print_message();

void pattern_write(unsigned long addr, unsigned long data);

#endif
